SystemOrganization addCategory: #Ani!

Object subclass: #Ani
	instanceVariableNames: 'stepTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!Ani classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/14/2011 18:17'!
steppingInstances

	^self allInstances select: [:each| each isStepping].! !

!Ani methodsFor: 'defaults' stamp: 'hjo 12/14/2011 16:23'!
defaultStepTime

	"Return a default object for instance variable stepTime."
	^17! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 18:15'!
isStepping

	^World isStepping: self! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 16:15'!
shouldGetStepsFrom: anObject

	^true! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 16:17'!
startStepping 

	World startStepping: self at: Time millisecondClockValue selector: #step arguments: #() stepTime: self stepTime  ! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 16:25'!
step

	self subclassResponsibility! !

!Ani methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:19'!
stepTime

	^stepTime setDefault: #defaultStepTime for: self withSetter: #stepTime:! !

!Ani methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:19'!
stepTime: aNumber
		
	stepTime := aNumber! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 16:18'!
stopStepping

	World stopStepping: self! !

Ani subclass: #DeterministicAni
	instanceVariableNames: 'duration progress animatedTime finishedOperation timeFunction animationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!DeterministicAni classSide methodsFor: 'instance creation' stamp: 'hjo 12/14/2011 17:38'!
duration: aNumber timeFunctionSelector: aSelector

	| instance |
	instance := self new.
	instance duration: aNumber.  
	instance perform: aSelector.
	^instance! !

!DeterministicAni classSide methodsFor: 'instance creation' stamp: 'hjo 12/14/2011 17:36'!
easeIn: aFloat 

	^self duration: aFloat timeFunctionSelector:  #useEaseInTimeFunction.! !

!DeterministicAni classSide methodsFor: 'instance creation' stamp: 'hjo 12/14/2011 17:36'!
easeInOut: aFloat 

	^self duration: aFloat timeFunctionSelector:  #useEaseInOutTimeFunction.! !

!DeterministicAni classSide methodsFor: 'instance creation' stamp: 'hjo 12/14/2011 17:36'!
easeOut: aFloat 

	^self duration: aFloat timeFunctionSelector:  #useEaseOutTimeFunction.! !

!DeterministicAni classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/14/2011 19:11'!
exampleCompareTimeFunctions

|m1 m2 m3 s1 s2 s3 d |

m1 := Morph new.
m2 := Morph new.
m3 := Morph new.
m1 openInWorld.
m2 openInWorld.
m3 openInWorld.
m2 left: m1 right.
m3 left: m2 right.

d := 5000.
s1 := DeterministicAni easeIn: d.
s2 := DeterministicAni easeOut: d.
s3 := DeterministicAni easeInOut: d.

s1 animationBlock: [:p | m1 color: (Color red alpha: p)].
s2 animationBlock: [:p | m2 color: (Color red alpha: p)].
s3 animationBlock: [:p | m3 color: (Color red alpha: p)].

s1 startStepping.
s2 startStepping.
s3 startStepping.

m1 delete.
m2 delete.
m3 delete.! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:37'!
animatedTime

	^animatedTime setDefault: #defaultAnimatedTime for: self withSetter: #animatedTime:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:51'!
animatedTime: aNumber
		
	animatedTime := aNumber! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:30'!
animationBlock

	^animationBlock setDefault: #defaultAnimationBlock for: self withSetter: #animationBlock:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:30'!
animationBlock: aBlockOf1Arg
		
	animationBlock := aBlockOf1Arg! !

!DeterministicAni methodsFor: 'assertions' stamp: 'hjo 12/14/2011 18:07'!
assertIfDurationIsTooShort

	self assert: [self duration >= self stepTime] description: 'duration is too short compared to stepTime.'! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 16:37'!
defaultAnimatedTime

	"Return a default object for instance variable animatedTime."
	^0! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 18:29'!
defaultAnimationBlock

	"Return a default object for instance variable stepBlock."
	^[:prog| Transcript cr; nextPutAll: 'default static animation operation(progress', prog asFloat printString ,')';flush]! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 16:45'!
defaultDuration

	"milliseconds"
	^2000! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 16:51'!
defaultFinishedOperation

	"Return a default object for instance variable finishedOperation."
	^[Transcript cr;nextPutAll:'animation finished normally.';flush]! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 17:06'!
defaultTimeFunction

	"Return a default object for instance variable timeFunction."
	^[:t| t]! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:21'!
duration

	^duration setDefault: #defaultDuration for: self withSetter: #duration:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:07'!
duration: aNumber
		
	duration := aNumber.
	self assertIfDurationIsTooShort.! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:51'!
finishedOperation

	^finishedOperation setDefault: #defaultFinishedOperation for: self withSetter: #finishedOperation:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:52'!
finishedOperation: aBlock
		
	finishedOperation := aBlock! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:37'!
progress

	^self animatedTime / self duration  ! !

!DeterministicAni methodsFor: 'stepping' stamp: 'hjo 12/14/2011 18:22'!
reset

	self animatedTime: nil.  ! !

!DeterministicAni methodsFor: 'stepping' stamp: 'hjo 12/14/2011 18:28'!
step

	self progress < 1.0
		ifTrue: [
			self animationBlock value: (self timeFunction value: self progress).
			self animatedTime: self animatedTime + self stepTime  
		]
		ifFalse: [
			self finishedOperation value.  
			self stopStepping.
		]  
	  
	! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 17:06'!
timeFunction

	^timeFunction setDefault: #defaultTimeFunction for: self withSetter: #timeFunction:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 17:43'!
timeFunction: aBlock
		
	timeFunction := aBlock! !

!DeterministicAni methodsFor: 'time functions' stamp: 'hjo 12/14/2011 17:21'!
useEaseInOutTimeFunction

	self timeFunction: [:t| t squared * (3 - (2*t)) ]  ! !

!DeterministicAni methodsFor: 'time functions' stamp: 'hjo 12/14/2011 17:16'!
useEaseInTimeFunction

	self timeFunction: [:t| t squared ]  ! !

!DeterministicAni methodsFor: 'time functions' stamp: 'hjo 12/14/2011 17:17'!
useEaseOutTimeFunction

	self timeFunction: [:t| t sqrt ]  ! !

Ani subclass: #EnvyAni
	instanceVariableNames: 'targetEvaluator currentEvaluator operation stiffness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!EnvyAni classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/14/2011 19:10'!
example

|m3 m4 dy|
m3 := Morph new.
m3 openInWorld.
m4 := Morph new.
m4 color: Color green.
m4 openInWorld.

dy := EnvyAni new.
dy startStepping.
dy targetEvaluator: [m3 right].  
dy currentEvaluator: [m4 left].  
dy operation: [:z| m4 left: z].
dy stiffness: 0.1.
dy stopStepping.! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:38'!
currentEvaluator

	^currentEvaluator setDefault: #defaultCurrentEvaluator for: self withSetter: #currentEvaluator:! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:49'!
currentEvaluator: aBlock
		
	self assert: [aBlock argumentCount = 0].
	currentEvaluator := aBlock! !

!EnvyAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 18:38'!
defaultCurrentEvaluator

	"Return a default object for instance variable currentEvaluator."
	^[6]! !

!EnvyAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 18:41'!
defaultOperation

	"Return a default object for instance variable operation."
	^[:newCurrent| "do something with newCurrent" ]! !

!EnvyAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 18:46'!
defaultStiffness

	"Return a default object for instance variable factor."
	^0.5! !

!EnvyAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 18:38'!
defaultTargetEvaluator

	"Return a default object for instance variable targetEvaluator."
	^[7]! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:54'!
nexAnimationValue
	^ self targetEvaluator value * self stiffness + (self currentEvaluator value * (1 - self stiffness))! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:41'!
operation

	^operation setDefault: #defaultOperation for: self withSetter: #operation:! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:49'!
operation: aBlock
		
	self assert: [aBlock argumentCount = 1].
	operation := aBlock! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:54'!
step

	self operation value: self nexAnimationValue! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:47'!
stiffness

	^stiffness setDefault: #defaultStiffness for: self withSetter: #stiffness:! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:50'!
stiffness: aNumber
		
	self assert: [aNumber between: 0 and: 1 ].
	stiffness := aNumber! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:38'!
targetEvaluator

	^targetEvaluator setDefault: #defaultTargetEvaluator for: self withSetter: #targetEvaluator:! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:50'!
targetEvaluator: aBlock

	self assert: [aBlock argumentCount = 0].		
	targetEvaluator := aBlock! !
